/* 
 * neutrino
 *
 * Copyright (c) 2012 Denis Rechkunov and project contributors.
 *
 * neutrino's license follows:
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, 
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.

 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 * 
 * This license applies to all parts of neutrino that are not externally
 * maintained libraries.
 */

var neutrino = require('../../index.js'),
	Barrier = require('../../common/patterns/barrier.js');

exports['Register tasks and use complete callback to get results'] = function (test) {

	test.expect(11);

	var barrier = new Barrier(),
		tasks = [];

	for (var i = 0; i < 5; i++) {
		(function (number) {

			var task = function (callback) {
				setTimeout(function () {

					callback(number);

				}, 100 * number);
			};
			tasks.push(task);
			barrier.registerTask(task);

		})(i);

	}

	barrier.execute(function (results) {

		test.deepEqual(results.length, 5);
		var i = 0;
		results.forEach(function (result) {
			test.deepEqual(result.result, i);
			test.deepEqual(result.task, tasks[i]);
			i++;
		});
		test.done();
	});

};