/*
 * neutrino
 *
 * Copyright (c) 2012 Denis Rechkunov and project contributors.
 *
 * neutrino's license follows:
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge,
 * publish, distribute, sublicense, and/or sell copies of the Software,
 * and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.

 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * This license applies to all parts of neutrino that are not externally
 * maintained libraries.
 */
var defaults = require('../../defaults.json'),
	Config = require('../../core/config.js'),
	testConfig = {
		level1: {
			level2: {
				level3: {
					hello: 'world'
				}
			}
		},
		worker: {
			ssl: {
				enabled: 'testTrue'
			}
		},
		level1Test2: 'value'
	},
	config = new Config(testConfig),
	config2 = new Config();

exports["Custom parameter value"] = function (test) {
	test.deepEqual(config.$('level1Test2'), testConfig.level1Test2);
	test.deepEqual(config.$('level1.level2.level3.hello'), testConfig.level1.level2.level3.hello);
	test.done();
};

exports["Custom parameter overrides default value"] = function (test) {
	test.deepEqual(config.$('worker.ssl.enabled'), testConfig.worker.ssl.enabled);
	test.done();
};

exports["Custom parameter is absent, but default exists"] = function (test) {
	test.deepEqual(config.$('charset'), defaults.charset);
	test.deepEqual(config.$('worker.ssl.keyPath'), defaults.worker.ssl.keyPath);
	test.done();
};

exports["Empty config was set in configure"] = function (test) {
	test.deepEqual(config2.$('smth.smth.smth'), null);
	test.done();
};
